# TODO
# - man -l pam_mount.8 | perl -pe 's/.\cH//g' >pam_mount.txt;
#   man: invalid option -- 'l'
#   man, version 1.6f
%define 	modulename pam_mount
Summary:	A PAM module that can mount remote volumes for a user session
Summary(pl.UTF-8):	Moduł PAM, pozwalający montować zdalne zasoby na czas sesji użytkownika
Name:		pam-%{modulename}
Version:	2.13
Release:	1
License:	LGPL
Group:		Base
Source0:	http://downloads.sourceforge.net/pam-mount/%{modulename}-%{version}.tar.xz
# Source0-md5:	9f75fc8e84ea9cde619cdd6a62c7de33
Source1:	%{name}.tmpfiles
URL:		http://pam-mount.sourceforge.net/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	cryptsetup-luks-devel >= 1.1.2
BuildRequires:	glib2-devel
BuildRequires:	libHX-devel >= 3.6
BuildRequires:	libmount-devel >= 2.20
BuildRequires:	libtool
BuildRequires:	libxml2-devel
BuildRequires:	openssl-devel >= 0.9.8
BuildRequires:	pam-devel
BuildRequires:	pkgconfig
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz >= 1:4.999.7
BuildRequires:	zlib-devel
Obsoletes:	pam_mount
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This module is aimed to environments with SMB (Samba or Windows NT)
and/or NCP (Netware or Mars-NWE) servers that Unix users want or need
to access, and some users have / every user has private volumes in
that servers. The module also supports mounting home directories using
loopback encrypted filesystems (see also
http://www.tldp.org/HOWTO/Loopback-Encrypted-Filesystem-HOWTO.html).
 - Every user can access his/her own volumes
 - The user needs to type the password just once (at login) (*)
 - The mouting process is transparent to the users
 - There is no need to keep the login passwords in any additional file
 - The volumes are unmount upon logout, so it saves system resources,
   avoiding the need of listing every every possibly useful remote volume
   in /etc/fstab or in an automount/supermount config file. This is also
   necessary for securing encrypted filesystems.

(*) Obviously, the user password in the Unix system and in the remote
servers must be the same ;)

Pam_mount "understands" SMB, NCP, and encrypted loopback volumes, but
this can be extended very easily.

%description -l pl.UTF-8
Przeznaczeniem tego modułu są środowiska z protokołem SMB (Samba lub
Windows NT) i/lub NCP (Netware lub Mars-NWE), w których użytkownicy
chcą lub potrzebują indywidualnych zasobów. Moduł ten wspiera także
montowanie katalogów domowych z zaszyfrowanych systemów plików przy
użyciu loopbacka (zobacz także:
http://www.tldp.org/HOWTO/Loopback-Encrypted-Filesystem-HOWTO.html).
 - każdy użytkownik ma dostęp do swoich zasobów
 - użytkownik musi wpisać swoje hasło tylko raz (przy logowaniu) (*)
 - proces montowania jest niewidzialny dla użytkownika
 - nie ma potrzeby trzymania hasła i loginu w żadnym dodatkowym pliku
 - katalogi są odmontowywane podczas wylogowania, co oszczędza zasoby
   systemowe, zabezpiecza przed koniecznością umieszczenia każdego
   potrzebnego zdalnego zasobu w /etc/fstab lub w konfiguracji
   automounta/supermounta. Jest to także konieczne do zabezpieczenia
   zaszyfrowanych systemów plików.

(*) Oczywiście hasło na lokalnym i zdalnym systemie musi być
identyczne ;)

pam_mount "rozumie" SMB, NCP oraz zaszyfrowane systemy plików po
loopbacku, ale może być rozszerzony w prosty sposób.

%package -n libcryptmount
Summary:	libcryptmount library
Summary(pl.UTF-8):	Biblioteka libcryptmount
Group:		Libraries

%description -n libcryptmount
libcryptmount library.

%description -n libcryptmount -l pl.UTF-8
Biblioteka libcryptmount

%package -n libcryptmount-devel
Summary:	Header files for libcryptmount library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libcryptmount
Group:		Development/Libraries
Requires:	libcryptmount = %{version}-%{release}

%description -n libcryptmount-devel
Header files for libcryptmount library.

%description -n libcryptmount-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libcryptmount.

%prep
%setup -q -n %{modulename}-%{version}

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--with-slibdir=/%{_lib} \
	--disable-static
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/security,/sbin,/var/run/pam_mount,%{_bindir}} \
	$RPM_BUILD_ROOT%{systemdtmpfilesdir}

%{__make} -j1 install \
	moduledir=/%{_lib}/security \
	DESTDIR=$RPM_BUILD_ROOT

cp -a config/pam_mount.conf.xml $RPM_BUILD_ROOT/etc/security
ln -sf /sbin/mount.crypt $RPM_BUILD_ROOT%{_bindir}/mount.crypt

install %{SOURCE1} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/pam_mount.conf

rm $RPM_BUILD_ROOT%{_libdir}/libcryptmount.la

%clean
rm -rf $RPM_BUILD_ROOT

%post   -n libcryptmount -p /sbin/ldconfig
%postun -n libcryptmount -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) /%{_lib}/security/pam_mount.so
%config(noreplace) %verify(not md5 mtime size) /etc/security/pam_mount.conf.xml
%attr(755,root,root) /sbin/mount.crypt
%attr(755,root,root) /sbin/mount.crypt_LUKS
%attr(755,root,root) /sbin/mount.crypto_LUKS
%attr(755,root,root) /sbin/umount.crypt
%attr(755,root,root) /sbin/umount.crypt_LUKS
%attr(755,root,root) /sbin/umount.crypto_LUKS
%attr(755,root,root) %{_bindir}/mount.crypt
%attr(755,root,root) %{_sbindir}/pmt-ehd
%attr(755,root,root) %{_sbindir}/pmvarrun
%dir /var/run/pam_mount
%{systemdtmpfilesdir}/pam_mount.conf
%{_mandir}/man5/pam_mount.conf.5*
%{_mandir}/man8/mount.crypt.8*
%{_mandir}/man8/mount.crypt_LUKS.8*
%{_mandir}/man8/mount.crypto_LUKS.8*
%{_mandir}/man8/pam_mount.8*
%{_mandir}/man8/pmt-ehd.8*
%{_mandir}/man8/pmvarrun.8*
%{_mandir}/man8/umount.crypt.8*
%{_mandir}/man8/umount.crypt_LUKS.8*
%{_mandir}/man8/umount.crypto_LUKS.8*

%files -n libcryptmount
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcryptmount.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcryptmount.so.0

%files -n libcryptmount-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcryptmount.so
%{_includedir}/libcryptmount.h
%{_pkgconfigdir}/libcryptmount.pc
%changelog
* Sun Feb 12 2012 Adam Gołębiowski <adamg@pld-linux.org> 707bab6
- updated to 2.13
- pass slibdir
- separate libcryptmount library
- adapterized

* Sun Feb 12 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 485b9f6
- release 5

* Thu Feb 09 2012 Adam Gołębiowski <adamg@pld-linux.org> 2fa616c
- release 4 (rebuild against libHX-3.12)

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 7793612
- release 3

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> cd348a8
- added tmpfiles config for systemd

* Mon Jan 30 2012 Jan Rękorajski <baggins@pld-linux.org> 7728e20
- add systemd tmpfiles config

* Sat Nov 26 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 314bcaf
- release 2

* Mon Oct 10 2011 lisu <lisu@pld-linux.org> b2d764f
- 2.12

* Thu Oct 06 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 82a49f0
- up to 2.11

* Thu Apr 21 2011 lisu <lisu@pld-linux.org> 169b58c
- updated to 2.10

* Thu Apr 07 2011 lisu <lisu@pld-linux.org> 0718b89
- BR: xz >= 1:4.999.7

* Thu Apr 07 2011 lisu <lisu@pld-linux.org> ad0a7e5
- updated to 2.9

* Thu Apr 07 2011 lisu <lisu@pld-linux.org> 6b7f417
- rel 2

* Wed Dec 22 2010 lisu <lisu@pld-linux.org> 30348e4
- 2.8

* Fri Dec 10 2010 lisu <lisu@pld-linux.org> 34544e9
- up to 2.7
- drop obsoleted rm

* Sun Oct 31 2010 Elan Ruusamäe <glen@pld-linux.org> ab50ba4
- up to 2.6
- pmt-ofl, pmt-fd0ssh dropped, use hxtools if you need them

* Mon Sep 20 2010 Elan Ruusamäe <glen@pld-linux.org> 971f395
- release 2

* Wed Aug 11 2010 lisu <lisu@pld-linux.org> d07314f
- cryptsetup-luks -> cryptsetup-luks-devel

* Wed Aug 11 2010 lisu <lisu@pld-linux.org> 4eaa0d9
- up to 2.5
- BR: cryptsetup-luks >= 1.1.2

* Mon Jul 19 2010 lisu <lisu@pld-linux.org> 73eaa33
- up to 2.4
- tar.xz package

